# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['BotmanJavascriptInjectionArgs', 'BotmanJavascriptInjection']

@pulumi.input_type
class BotmanJavascriptInjectionArgs:
    def __init__(__self__, *,
                 config_id: pulumi.Input[int],
                 javascript_injection: pulumi.Input[str],
                 security_policy_id: pulumi.Input[str]):
        """
        The set of arguments for constructing a BotmanJavascriptInjection resource.
        """
        pulumi.set(__self__, "config_id", config_id)
        pulumi.set(__self__, "javascript_injection", javascript_injection)
        pulumi.set(__self__, "security_policy_id", security_policy_id)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Input[int]:
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: pulumi.Input[int]):
        pulumi.set(self, "config_id", value)

    @property
    @pulumi.getter(name="javascriptInjection")
    def javascript_injection(self) -> pulumi.Input[str]:
        return pulumi.get(self, "javascript_injection")

    @javascript_injection.setter
    def javascript_injection(self, value: pulumi.Input[str]):
        pulumi.set(self, "javascript_injection", value)

    @property
    @pulumi.getter(name="securityPolicyId")
    def security_policy_id(self) -> pulumi.Input[str]:
        return pulumi.get(self, "security_policy_id")

    @security_policy_id.setter
    def security_policy_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "security_policy_id", value)


@pulumi.input_type
class _BotmanJavascriptInjectionState:
    def __init__(__self__, *,
                 config_id: Optional[pulumi.Input[int]] = None,
                 javascript_injection: Optional[pulumi.Input[str]] = None,
                 security_policy_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering BotmanJavascriptInjection resources.
        """
        if config_id is not None:
            pulumi.set(__self__, "config_id", config_id)
        if javascript_injection is not None:
            pulumi.set(__self__, "javascript_injection", javascript_injection)
        if security_policy_id is not None:
            pulumi.set(__self__, "security_policy_id", security_policy_id)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> Optional[pulumi.Input[int]]:
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "config_id", value)

    @property
    @pulumi.getter(name="javascriptInjection")
    def javascript_injection(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "javascript_injection")

    @javascript_injection.setter
    def javascript_injection(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "javascript_injection", value)

    @property
    @pulumi.getter(name="securityPolicyId")
    def security_policy_id(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "security_policy_id")

    @security_policy_id.setter
    def security_policy_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "security_policy_id", value)


class BotmanJavascriptInjection(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 javascript_injection: Optional[pulumi.Input[str]] = None,
                 security_policy_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a BotmanJavascriptInjection resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: BotmanJavascriptInjectionArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a BotmanJavascriptInjection resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param BotmanJavascriptInjectionArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(BotmanJavascriptInjectionArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 javascript_injection: Optional[pulumi.Input[str]] = None,
                 security_policy_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = BotmanJavascriptInjectionArgs.__new__(BotmanJavascriptInjectionArgs)

            if config_id is None and not opts.urn:
                raise TypeError("Missing required property 'config_id'")
            __props__.__dict__["config_id"] = config_id
            if javascript_injection is None and not opts.urn:
                raise TypeError("Missing required property 'javascript_injection'")
            __props__.__dict__["javascript_injection"] = javascript_injection
            if security_policy_id is None and not opts.urn:
                raise TypeError("Missing required property 'security_policy_id'")
            __props__.__dict__["security_policy_id"] = security_policy_id
        super(BotmanJavascriptInjection, __self__).__init__(
            'akamai:index/botmanJavascriptInjection:BotmanJavascriptInjection',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            config_id: Optional[pulumi.Input[int]] = None,
            javascript_injection: Optional[pulumi.Input[str]] = None,
            security_policy_id: Optional[pulumi.Input[str]] = None) -> 'BotmanJavascriptInjection':
        """
        Get an existing BotmanJavascriptInjection resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _BotmanJavascriptInjectionState.__new__(_BotmanJavascriptInjectionState)

        __props__.__dict__["config_id"] = config_id
        __props__.__dict__["javascript_injection"] = javascript_injection
        __props__.__dict__["security_policy_id"] = security_policy_id
        return BotmanJavascriptInjection(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Output[int]:
        return pulumi.get(self, "config_id")

    @property
    @pulumi.getter(name="javascriptInjection")
    def javascript_injection(self) -> pulumi.Output[str]:
        return pulumi.get(self, "javascript_injection")

    @property
    @pulumi.getter(name="securityPolicyId")
    def security_policy_id(self) -> pulumi.Output[str]:
        return pulumi.get(self, "security_policy_id")

